Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr.sort
Class AlphanumericCollator

    java.lang.Object
      net.sf.saxon.expr.sort.AlphanumericCollator

All Implemented Interfaces:
  Serializable, StringCollator

    public class AlphanumericCollator

extends Object
implements StringCollator, Serializable

A Comparer that treats strings as an alternating sequence of alpha parts and numeric parts. The alpha parts are compared using a base collation supplied as a parameter; the numeric parts are compared numerically. "Numeric" here means a sequence of consecutive ASCII digits 0-9.

Note: this StringCollator produces an ordering that is not compatible with equals().

See Also:
  Serialized Form

Constructor Summary
`AlphanumericCollator(StringCollator base)` Create an alphanumeric collation

Method Summary
`boolean` | `comparesEqual(String s1, String s2)` Compare two strings for equality.
`int` | `compareStrings(String s1, String s2)` Compare two objects.
`Object` | `getCollationKey(String s)` Get a collation key for two Strings.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AlphanumericCollator

    public AlphanumericCollator(StringCollator base)

  Create an alphanumeric collation

  Parameters:
    `base` - the collation used to compare the alphabetic parts of the string

Method Detail

### compareStrings

    public int compareStrings(String s1,
                              String s2)

  Compare two objects.

  Specified by:
    `compareStrings` in interface `StringCollator`
  Parameters:
    `s1` - the first string
    `s2` - the second string
  Returns:
    <0 if a 0 if a>b

### comparesEqual

    public boolean comparesEqual(String s1,
                                 String s2)

  Compare two strings for equality. This may be more efficient than using compareStrings and testing whether the result is zero, but it must give the same result

  Specified by:
    `comparesEqual` in interface `StringCollator`
  Parameters:
    `s1` - the first string
    `s2` - the second string
  Returns:
    true if and only if the strings are considered equal,

### getCollationKey

    public Object getCollationKey(String s)

  Get a collation key for two Strings. The essential property of collation keys is that if two values are equal under the collation, then the collation keys are compare correctly under the equals() method.

  Specified by:
    `getCollationKey` in interface `StringCollator`
  Parameters:
    `s` - the string whose collation key is required
  Returns:
    the collation key

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.